/****************************************************************************/
//    copyright 2012  Chris Rizzitello <sithlord48@gmail.com>               //
//                                                                          //
//    This file is part of FF7tk                                            //
//                                                                          //
//    FF7tk is free software: you can redistribute it and/or modify         //
//    it under the terms of the GNU General Public License as published by  //
//    the Free Software Foundation, either version 3 of the License, or     //
//    (at your option) any later version.                                   //
//                                                                          //
//    FF7tk is distributed in the hope that it will be useful,              //
//    but WITHOUT ANY WARRANTY; without even the implied warranty of        //
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          //
//    GNU General Public License for more details.                          //
/****************************************************************************/

#ifndef FF7_SAVE_CONSTS_H
#define FF7_SAVE_CONSTS_H
#include <QByteArray>

/*~~~~~~~~~~~~~~~~~~PC Save File ~~~~~~~~~~~~*/
  const int FF7_PC_SAVE_GAME_SIZE = 0xFE55;
  const int FF7_PC_SAVE_GAME_HEADER = 0x09;
  const int FF7_PC_SAVE_GAME_FOOTER = 0x0000;
  const int FF7_PC_SAVE_GAME_DATA_SIZE = 0x10F4;
  const int FF7_PC_SAVE_GAME_SLOT_HEADER = 0x00;
  const int FF7_PC_SAVE_GAME_SLOT_FOOTER = 0x0000;
  const int FF7_PC_SAVE_GAME_SLOT_SIZE = 0x10F4;
  const int FF7_PC_SAVE_GAME_SLOT_NUMBER = 15;
  const QByteArray PC_SAVE_GAME_FILE_ID = "\x71\x73";
  const quint8 PC_SAVE_GAME_FILE_HEADER[0x09] = {0x71,0x73,0x27,0x06,0x00,0x00,0x00,0x00,0x00}; //PC HEADER (for when we need to create one)

  /*~~~~~~~~~~~~~~~~~~ Psx save file ~~~~~~~~~~~~~~~~*/
  const int FF7_PSX_SAVE_GAME_SIZE = 0x2000;
  const int FF7_PSX_SAVE_GAME_HEADER = 0x0000;
  const int FF7_PSX_SAVE_GAME_FOOTER = 0x0000;
  const int FF7_PSX_SAVE_GAME_DATA_SIZE = 0x10F4;
  const int FF7_PSX_SAVE_GAME_SLOT_HEADER = 0x0200;
  const int FF7_PSX_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
  const int FF7_PSX_SAVE_GAME_SLOT_SIZE = 0x2000;
  const int FF7_PSX_SAVE_GAME_SLOT_NUMBER = 1;
  const QByteArray PSX_SAVE_GAME_FILE_ID = "\x53\x43\x11\x01\x82\x65\x82\x65\x82\x56\x81\x5E\x82\x72\x82\x60";

//BELOW 1/2 HEADER DATA FOR EACH PSX SAVE SLOT, (NOTE: last 256 bytes are 0x00, no region data in this section)

//Slot 01 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S01[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x50, 0x81,0x5E,0x82,0x4F, 0x82,0x58,0x81,0x46,
 0x82,0x54,0x82,0x4F, 0x00,0x00,0x00,0x00, 0x62,0x75,0x31,0x30, 0x3A,0x00,0x00,0x00, 0x62,0x75,0x30,0x30, 0x3A,0x00,0x00,0x00, 0xA0,0x3B,0x1D,0x80, 0x8C,0x3C,0x1D,0x80,
 0x00,0x3F,0x1D,0x80, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1D,0x57, 0xDD,0x3E,0xBA,0x42, 0xB7,0x5E,0x53,0x5A, 0x38,0x2E,0xF8,0x1D, 0xF3,0x39,0xEE,0x59, 0xEC,0x71,0xB3,0x1D, 0x8E,0x39,0x87,0x7D, 0x08,0x31,0xFF,0x7F,
 0xFF,0x15,0x21,0x76, 0xF3,0xFF,0xFF,0xFF, 0xDF,0x5D,0x32,0x63, 0x66,0xDA,0xDD,0xFD, 0xDF,0x8A,0x66,0x77, 0x77,0x56,0xDD,0xFD, 0x4F,0x71,0x68,0x13, 0x7B,0x22,0xD5,0xFD,
 0x55,0x47,0x11,0x81, 0x3E,0x22,0xA2,0xFD, 0xDF,0x15,0x11,0xB3, 0x5E,0x72,0x52,0xF8, 0xAF,0x32,0x31,0x2B, 0x61,0xB2,0x77,0xFD, 0x8F,0x37,0x62,0x16, 0x61,0x73,0x67,0xF8,
 0xCF,0x67,0xBB,0x32, 0xB8,0x76,0xBB,0xFD, 0xBF,0x76,0xEB,0xB3, 0xEC,0xB7,0xCB,0xF8, 0x7F,0xB7,0x1B,0x31, 0x11,0xE7,0xD7,0xFD, 0x7F,0x5B,0x38,0x31, 0x11,0xEB,0xD8,0xFD,
 0xBF,0xAA,0xB7,0x11, 0x31,0xEB,0xDC,0xFD, 0xAF,0xDD,0xB8,0x18, 0xB3,0xCE,0xDE,0xFD, 0xDF,0xDD,0xBA,0xED, 0xCC,0xCC,0xDE,0xFD, 0xFF,0xFF,0xBF,0xEF, 0x5C,0xEC,0xEE,0xFF};

//Slot 02 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S02[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x51, 0x81,0x5E,0x82,0x58, 0x82,0x58,0x81,0x46,
 0x82,0x54,0x82,0x58, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x50, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1B,0x63, 0x5A,0x42,0x72,0x62, 0x11,0x4A,0xB6,0x2D, 0xEC,0x69,0x56,0x21, 0x90,0x31,0x87,0x7D, 0x8C,0x39,0x29,0x2D, 0x0D,0x1D,0xE8,0x1C, 0xC7,0x14,0xFF,0x7F,
 0xFF,0xFF,0x1F,0x44, 0xAA,0xFF,0xFF,0xFF, 0x9F,0x99,0x36,0xC4, 0xED,0x9A,0x99,0xF9, 0x9F,0x99,0xFA,0x72, 0xC7,0x9C,0x99,0xF9, 0x9F,0x99,0xF1,0x51, 0x75,0xAC,0x99,0xF9,
 0x9F,0x39,0xFF,0x84, 0x77,0xDC,0x94,0xF9, 0x9F,0x39,0x82,0x8B, 0x57,0xCC,0x6A,0xF9, 0x9F,0x89,0xCC,0x21, 0x75,0xDD,0xEC,0xFB, 0x9F,0x49,0x82,0x11, 0xC7,0xEE,0xCD,0xDE,
 0x9F,0x89,0xBC,0xBD, 0xEC,0xEE,0x7E,0xDC, 0x9F,0xB9,0x38,0xD4, 0xEE,0xEE,0x7E,0xC7, 0x9F,0xDA,0x85,0x52, 0xED,0xEE,0xCE,0xC7, 0xAF,0xED,0xDC,0xCC, 0xEE,0xEE,0xCE,0x77,
 0xCF,0xED,0xBB,0xED, 0xEE,0xEE,0xCE,0x57, 0x84,0xEB,0xBB,0xEE, 0xEE,0xEE,0x7C,0x57, 0x58,0xD8,0xEE,0xEE, 0xCE,0x77,0x7C,0x25, 0x85,0xD8,0xCE,0xC7, 0x7C,0x75,0x5C,0x22};

//Slot 03 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S03[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x52, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x51, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x51, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1C,0x5F, 0x9B,0x4A,0x95,0x5E, 0x56,0x4A,0xBA,0x3D, 0x11,0x4E,0xD4,0x39, 0xEC,0x69,0xA9,0x79, 0xAF,0x41,0x74,0x21, 0x86,0x7D,0x4F,0x25, 0xEF,0x18,0xFF,0x7F,
 0xFF,0xFF,0x1F,0x44, 0xF1,0xFF,0xFF,0xFF, 0x8F,0x88,0x88,0x27, 0xA2,0xC8,0xCC,0xFC, 0x3F,0x77,0xA7,0x2B, 0x21,0xC4,0xCC,0xFC, 0x1F,0xE7,0x7E,0xED, 0xFF,0x61,0xCC,0xFC,
 0x1F,0xAB,0xEE,0xED, 0x1B,0x21,0xC6,0xFC, 0x2F,0xCB,0x2A,0x1F, 0x7B,0x25,0x87,0xFC, 0xBF,0xCD,0x16,0x1F, 0xBB,0x7B,0x74,0xF8, 0xDF,0xCD,0xF6,0x4F, 0xBE,0xBB,0x74,0xF8,
 0x8F,0xCD,0xA6,0xD1, 0xEE,0xBE,0xED,0xF6, 0xCF,0xC8,0x8B,0x11, 0xD8,0xEE,0xE7,0x15, 0xCF,0xCC,0xFE,0xF2, 0xDF,0xEB,0xED,0x5E, 0xCF,0xCC,0x1E,0xF1, 0x2F,0xEB,0xBE,0xBB,
 0xCF,0xCC,0xBE,0xF1, 0xB1,0xBE,0xEE,0x55, 0xCF,0xEC,0xEB,0x2B, 0xED,0xBE,0xEE,0xF4, 0xCF,0xEC,0xBB,0xBE, 0xB2,0xBE,0xEE,0x1A, 0xFF,0x1F,0xBE,0xFE, 0x51,0xEE,0xEE,0x34};

//Slot 04 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S04[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x53, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x51, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x52, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x9D,0x73, 0x5B,0x6B,0xF9,0x5E, 0xF6,0x6A,0xD5,0x62, 0x77,0x52,0x2E,0x6E, 0x31,0x4A,0x76,0x18, 0xC9,0x75,0x6A,0x49, 0x77,0x31,0x86,0x7D, 0x09,0x31,0xFF,0x7F,
 0xFF,0xFF,0x7F,0xA8, 0xFF,0xFF,0xFF,0xFF, 0xDF,0x77,0xB7,0xA6, 0xDD,0xDD,0xDD,0xFD, 0xAF,0x68,0xEC,0xAC, 0x7D,0xA7,0xAF,0xFA, 0xB7,0x3C,0xE8,0xBE, 0x7D,0x5F,0x7F,0xFF,
 0xEB,0xEE,0xEE,0xEE, 0xC9,0xF6,0x1F,0x55, 0xC6,0xEE,0x8B,0xEB, 0x6C,0x13,0xF1,0xFF, 0xBF,0xEE,0xF8,0xBE, 0xFE,0x1F,0x21,0x5A, 0xDF,0xBE,0xFE,0x51, 0xBE,0x47,0x55,0x24,
 0x9F,0xEB,0x38,0x6C, 0xF3,0xFF,0xFF,0x31, 0x8F,0xE8,0x6E,0x36, 0xF2,0x6F,0x11,0xF3, 0xF8,0x81,0x22,0x22, 0xFF,0x1F,0x62,0x36, 0x18,0x56,0xFF,0xFF, 0x21,0x12,0xF1,0x1F,
 0x8F,0xF5,0xF6,0x21, 0x12,0xFF,0xFF,0xFF, 0x5F,0xF1,0x11,0x13, 0xFF,0xFF,0xF1,0xFF, 0x14,0x33,0x33,0xF1, 0x1F,0x1F,0xF3,0xFF, 0x13,0xF3,0x16,0xFF, 0x3F,0x31,0xFF,0x1F};

//Slot 05 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S05[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x54, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x53, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x1E,0x2E, 0x36,0x3E,0xD7,0x2D, 0x5C,0x21,0xCC,0x65, 0xB0,0x49,0x8C,0x10, 0xAE,0x51,0x9C,0x73, 0x87,0x7D,0x35,0x1D, 0x11,0x29,0x0D,0x25, 0xB0,0x14,0xFF,0x7F,
 0xFF,0x99,0x99,0xCE, 0x89,0xCE,0xEE,0xBC, 0xAF,0xEC,0xCE,0xEE, 0xEC,0xC7,0xBE,0x4B, 0xAF,0xAA,0xEE,0xE7, 0x7E,0xE7,0x4B,0xE4, 0xAF,0xDC,0xCD,0x77, 0x7E,0xEE,0xEE,0xEE,
 0xCF,0xEE,0xEE,0x7E, 0xEE,0xBE,0xBB,0xBE, 0xAF,0xAA,0xDC,0xEE, 0xBE,0x44,0x7D,0x3B, 0xAF,0xAA,0xAA,0xBB, 0x11,0x14,0x7D,0x13, 0xAF,0xAA,0xEA,0x44, 0x43,0x11,0x73,0x11,
 0xAF,0xAA,0xD5,0xDE, 0x39,0x11,0xD4,0x33, 0xAF,0x5A,0xCC,0x14, 0x43,0xEE,0xDB,0x95, 0xAF,0xDA,0x47,0x41, 0x4B,0x41,0xDE,0xFA, 0xAF,0x6A,0x11,0xB1, 0xE8,0xBE,0x8E,0xFA,
 0xAF,0xAA,0x13,0x64, 0xA2,0xC5,0x2D,0xFA, 0xAF,0xAA,0x35,0x83, 0xAC,0xAA,0x85,0xFA, 0xAF,0xAA,0xAA,0x8A, 0xAC,0xAA,0xEA,0xFA, 0xFF,0xFF,0xFF,0x9F, 0xF9,0xFF,0xE9,0xF5};

//Slot 06 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S06[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x55, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x54, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x3C,0x5B, 0x3E,0x4F,0xDD,0x36, 0x99,0x46,0x1C,0x22, 0x30,0x62,0x8D,0x31, 0x32,0x46,0xD0,0x35, 0xCB,0x59,0xA8,0x79, 0x86,0x7D,0x71,0x21, 0x4B,0x29,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x46, 0x64,0xF6,0xFF,0xFF, 0xCF,0xCC,0x6C,0x21, 0x32,0x64,0xCC,0xFC, 0xCF,0xCC,0x16,0xFF, 0xFF,0x22,0xC6,0xFC, 0xCF,0xAC,0x23,0xF1, 0x2F,0x23,0x63,0xFC,
 0xCF,0x84,0xDD,0x88, 0x34,0x54,0x35,0xFA, 0xAF,0x84,0xEE,0x44, 0xD8,0x49,0x55,0xF6, 0xAF,0xEE,0xED,0x48, 0xE8,0x18,0x54,0xF4, 0xCF,0xDA,0x77,0xED, 0xEE,0x8E,0x58,0xF5,
 0xCF,0x8C,0xDD,0xDE, 0x44,0x88,0xD8,0xF6, 0xCF,0x8C,0x22,0x44, 0x31,0x43,0xAA,0xFC, 0xCF,0xAC,0x44,0xF1, 0x52,0x45,0xAA,0xFC, 0xCF,0xAC,0x48,0x48, 0xD5,0xDD,0xA8,0xFC,
 0xAF,0x48,0xF2,0x58, 0x7D,0x77,0xEE,0xF7, 0xAF,0xC4,0x46,0x42, 0x77,0xEE,0xEE,0xF7, 0xCF,0xCC,0x8A,0xE8, 0xEE,0xEE,0x7E,0xA7, 0xFF,0xAF,0xEE,0xEE, 0x77,0xEE,0x7E,0xA8};

//Slot 07 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S07[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x56, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x55, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x7D,0x6B, 0x18,0x63,0xDC,0x4A, 0x77,0x4A,0x51,0x5E, 0x32,0x46,0xCC,0x65, 0xA9,0x75,0x86,0x7D, 0x8D,0x31,0x69,0x49, 0x29,0x25,0x28,0x25, 0xE7,0x1C,0xFF,0x7F,
 0xFF,0xFF,0xFF,0xFF, 0xFF,0xFF,0xFF,0xFF, 0x8F,0x88,0xA8,0x65, 0xA6,0xAC,0x88,0xF8, 0x8F,0x88,0xDA,0xAA, 0xEE,0xCC,0x88,0xF8, 0x8F,0xA8,0xAE,0x66, 0xEA,0xAA,0xAA,0xF8,
 0x8F,0xD8,0xAE,0x6A, 0x46,0xEA,0xAE,0xF8, 0x8F,0xE8,0xEE,0xAC, 0xF3,0xE4,0xAC,0xF8, 0x8F,0xEA,0xAA,0xA6, 0x16,0xE2,0x66,0xFA, 0x8F,0xEA,0x33,0x41, 0x2C,0xE6,0x22,0xFA,
 0x8F,0xEA,0x31,0x1F, 0xF2,0xA6,0x22,0xFA, 0x8F,0xEA,0x34,0xF1, 0xFF,0x42,0x16,0xF5, 0x8F,0xEA,0x3A,0xFF, 0x1F,0xDA,0x2A,0xF2, 0x8F,0xEA,0x4E,0x22, 0x11,0x2E,0x6C,0xF6,
 0x8F,0xEA,0xEE,0x3E, 0x1F,0xFE,0xAE,0x66, 0x8F,0xE8,0xEE,0x1A, 0xFF,0xEE,0xAE,0xAA, 0x8F,0xEA,0xEE,0x14, 0xFF,0xE6,0xEE,0xAC, 0xFF,0xE5,0x6E,0x13, 0xFF,0xC1,0xEE,0xCE};

//Slot 08 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S08[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x57, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x56, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xD8,0x56, 0x3D,0x46,0xDC,0x4A, 0xDC,0x3D,0x0E,0x52, 0xB5,0x39,0xC9,0x71, 0xAE,0x35,0x87,0x7D, 0x17,0x21,0x6A,0x35, 0xF3,0x20,0xEF,0x1C, 0xE8,0x1C,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x1F, 0x11,0xFF,0xFF,0xFF, 0x9F,0x99,0xB7,0x8B, 0xEB,0xBE,0x99,0xF9, 0x9F,0x79,0xEB,0x18, 0x81,0xEE,0x9B,0xF9, 0x9F,0xB7,0xEE,0x8E, 0xF5,0xE8,0xBE,0xF9,
 0x7F,0xEB,0xEE,0xEE, 0x5B,0xE8,0xEE,0xF9, 0xBF,0xDD,0xDC,0xDD, 0xEE,0xEE,0xEE,0xFB, 0xBF,0xCD,0xAA,0x4A, 0xEC,0xEC,0xEE,0xFB, 0xBF,0xCD,0xEE,0xAC, 0xEA,0xED,0xEE,0xFB,
 0xE1,0xDD,0xEB,0x4A, 0xEC,0xEC,0xEE,0xFB, 0xEE,0x8E,0xEB,0xDE, 0xDE,0xEE,0xEE,0xFB, 0xED,0x6E,0xEB,0xF3, 0x33,0xEE,0xEE,0xFE, 0xDD,0x8C,0xCE,0xFF, 0x3F,0xEE,0xEE,0xFE,
 0xCC,0x8A,0xCE,0x36, 0xE6,0xDE,0xEE,0xFE, 0xAA,0x64,0xAE,0xA4, 0xDD,0xCD,0xBE,0xFE, 0x46,0x62,0xAD,0x12, 0x1F,0xC1,0xBE,0x1C, 0x24,0x64,0x44,0x44, 0xAA,0xCC,0xEE,0xCA};

//Slot 09 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S09[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x58, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x57, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x3E,0x4F, 0xDC,0x4E,0x13,0x42, 0x52,0x4A,0xB0,0x35, 0x4D,0x29,0xB5,0x56, 0xA9,0x75,0xA8,0x14, 0xA7,0x7D,0xC7,0x29, 0x89,0x4D,0xEA,0x1C, 0x66,0x1D,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x44, 0x44,0xFF,0xFF,0xFF, 0xAF,0xAA,0x6C,0x55, 0xD6,0xCD,0xAA,0xFA, 0xAF,0xCA,0x35,0x53, 0x65,0xDD,0xAC,0xFA, 0xAF,0x5C,0x33,0x35, 0x55,0xD6,0xAD,0xFA,
 0xAF,0x35,0x53,0x33, 0x35,0xD6,0xC9,0xFA, 0xAF,0x35,0x53,0x53, 0x56,0x66,0xD9,0xFA, 0xAF,0x36,0x63,0x65, 0x69,0x67,0xDD,0xFA, 0xAF,0x5D,0x93,0x96, 0x49,0x94,0xDD,0xFA,
 0xAF,0x6D,0x65,0x67, 0x21,0x61,0x6D,0xFA, 0xAF,0xDC,0x56,0x12, 0x21,0x32,0xC6,0xFA, 0xAF,0xEC,0x6D,0x12, 0x31,0x32,0xAC,0xFA, 0xAF,0xBE,0xD9,0x23, 0x74,0xD3,0xAC,0xFA,
 0xCF,0xEE,0xE9,0x3D, 0x32,0x9D,0xC4,0xFA, 0xEF,0xEB,0xE8,0x6B, 0xDD,0x99,0xB7,0xFC, 0xEC,0x3E,0xE2,0xEB, 0xEE,0xEE,0x47,0xBB, 0xBE,0x13,0xBE,0xEB, 0xEB,0x4E,0x47,0xB4};

//Slot 10 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S10[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x4F, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x4F,0x82,0x58, 0x81,0x5E,0x82,0x4F,
 0x82,0x4F,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xFC,0x52, 0x7B,0x36,0x74,0x4E, 0x72,0x5E,0x15,0x32, 0xF2,0x39,0x0C,0x6E, 0xC9,0x79,0xA8,0x7D, 0x9C,0x73,0x8F,0x29, 0xAD,0x35,0x86,0x7D, 0x29,0x29,0xFF,0x7F,
 0xFF,0xFF,0xFF,0xAA, 0xAA,0xFF,0xFF,0xFF, 0xDF,0xDD,0x79,0x53, 0xB6,0xD8,0xDD,0xFD, 0xDF,0x9D,0x24,0x22, 0x55,0x8B,0xDD,0xFD, 0xDF,0x4D,0x21,0x22, 0x22,0xB5,0xD8,0xFD,
 0xDF,0x29,0x52,0x5B, 0xB5,0xBB,0x9C,0xFD, 0xDF,0x29,0x21,0x53, 0x26,0xB2,0x8B,0xFD, 0xDF,0x39,0xFF,0xFF, 0x1F,0x52,0x52,0xFD, 0xDF,0x39,0xF1,0xFF, 0x1F,0x62,0x2B,0xFD,
 0xDF,0x67,0xE6,0x16, 0xE3,0x5C,0x2B,0xFD, 0xDF,0xC8,0xFF,0xF1, 0x12,0x52,0x57,0xFD, 0xDF,0xCD,0xF1,0xFF, 0xF2,0x72,0x7D,0xFD, 0xDF,0xDD,0xFC,0x1F, 0x12,0x76,0x9D,0xFD,
 0xDF,0x9D,0xCE,0xFF, 0x51,0xCE,0xD9,0xFD, 0xDF,0x6D,0xEE,0x3C, 0xE5,0xEE,0x96,0xFD, 0xDA,0xC6,0xCE,0xEE, 0xEE,0xEE,0x6C,0xA9, 0x11,0xC6,0xEE,0xCC, 0xEC,0xEE,0x6C,0x16};

//Slot 11 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S11[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x50, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x52, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x4F, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xBE,0x67, 0xFB,0x52,0x79,0x3A, 0x31,0x4A,0x14,0x36, 0xFF,0x7F,0x83,0x10, 0xD0,0x35,0x87,0x7D, 0x19,0x6B,0x6A,0x35, 0x2A,0x25,0x27,0x35, 0xE5,0x24,0xFF,0x7F,
 0xFF,0xFF,0xFF,0xFF, 0xFF,0xFF,0xFF,0xFF, 0x9F,0x99,0x99,0xBB, 0xBC,0x99,0x99,0xF9, 0x9F,0x99,0xB9,0xEC, 0xEE,0x9E,0x99,0xF9, 0x9F,0x99,0xCB,0xCC, 0xCE,0xBE,0x99,0xF9,
 0x9F,0x99,0x2B,0x53, 0x35,0xC5,0x99,0xF9, 0x9F,0x99,0x18,0x11, 0x11,0x82,0x99,0xF9, 0x9F,0x99,0x14,0x11, 0x11,0x83,0x99,0xF9, 0x9F,0x49,0x84,0x2B, 0x82,0x5B,0x94,0xF9,
 0x9F,0x89,0x22,0x12, 0x33,0x53,0x9B,0xF9, 0x9F,0xB9,0x1C,0x11, 0x13,0xC2,0x9E,0xF9, 0x9F,0xE9,0x47,0x11, 0x23,0xE5,0xBE,0xF9, 0x9F,0x7B,0xC7,0x22, 0x52,0xEB,0xE7,0xF9,
 0xBA,0x77,0x87,0x54, 0xC5,0xB4,0x77,0xAB, 0x7B,0x77,0x8E,0xC1, 0x4C,0xE4,0x7E,0xBD, 0xEE,0xE7,0xBE,0xE2, 0x8E,0xEB,0x7D,0xDE, 0xDE,0x7E,0xEE,0xC8, 0x8C,0xDE,0xE7,0xEE};

//Slot 12 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S12[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x51, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x53, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x50, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0xBF,0x6F, 0x7C,0x6B,0x1B,0x5B, 0xBB,0x3E,0xD7,0x4E, 0x97,0x3A,0x31,0x56, 0x14,0x32,0x9C,0x73, 0xED,0x59,0xD1,0x2D, 0x09,0x21,0x86,0x7D, 0x8D,0x35,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x99, 0xF9,0xFF,0xFF,0xFF, 0xDF,0xDD,0x5A,0x65, 0x76,0xDA,0xDD,0xFD, 0xDF,0xAD,0x55,0x66, 0x68,0xA5,0xDD,0xFD, 0xDF,0x5D,0x63,0x86, 0x66,0x54,0xDD,0xFD,
 0xDF,0x3A,0x86,0x36, 0x41,0x48,0xDA,0xFD, 0xDF,0x57,0x68,0x12, 0x41,0x68,0xDA,0xFD, 0xDF,0x67,0x3B,0x81, 0x4B,0x88,0xD7,0xFD, 0xDF,0x67,0x3B,0x61, 0x8C,0xB8,0xDA,0xFD,
 0xDF,0x67,0x13,0x11, 0x44,0xB8,0xDD,0xFD, 0xDF,0x6A,0x21,0x14, 0x43,0xEB,0xDD,0xFD, 0xDF,0x7A,0x25,0x25, 0xB4,0xDE,0xDD,0xFD, 0xDF,0x7D,0x5B,0x63, 0xBB,0xDD,0xDD,0xFD,
 0xDF,0xAD,0xD7,0x6A, 0x84,0xDE,0xDD,0xFD, 0xDF,0xDD,0xD7,0x2E, 0xE3,0xEC,0xDD,0xFD, 0xDF,0xDD,0xEA,0x5C, 0xCE,0xCC,0xDE,0x9D, 0xFF,0x9F,0xCE,0xEC, 0xCC,0xCC,0xEC,0x9A};

//Slot 13 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S13[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x52, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x53, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x51, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x5A,0x6B, 0x1F,0x4B,0xFE,0x42, 0xF9,0x5E,0xB8,0x4E, 0x36,0x36,0x31,0x52, 0x9C,0x73,0xC4,0x24, 0x8B,0x45,0xAE,0x35, 0x86,0x7D,0x4D,0x21, 0x06,0x2D,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x88, 0x88,0xFF,0xFF,0xFF, 0xCF,0xCC,0xAC,0x77, 0x77,0xCA,0xCC,0xFC, 0xCF,0xCC,0x5A,0x22, 0x33,0xC5,0xCC,0xFC, 0xCF,0xCC,0x25,0x32, 0x33,0x73,0xCC,0xFC,
 0xCF,0xCC,0x25,0x33, 0x33,0x73,0xCC,0xFC, 0xCF,0xCC,0x25,0x33, 0x23,0xB3,0xCC,0xFC, 0xCF,0xCC,0x67,0xBB, 0xBB,0xB6,0xCC,0xFC, 0xCF,0xAC,0xEB,0xDE, 0xED,0xDE,0xC7,0xFC,
 0xCF,0x7C,0x65,0x5B, 0x6B,0xDB,0xC7,0xFC, 0xCF,0x7C,0x37,0x22, 0x26,0xB6,0xCC,0xFC, 0xCF,0xCC,0x67,0x52, 0x66,0xCD,0xCC,0xFC, 0xCF,0xCC,0x6A,0x33, 0x63,0xAE,0xCC,0xFC,
 0xCF,0xAC,0x59,0xDB, 0xED,0xEB,0xCA,0xFC, 0xC8,0x9A,0x1E,0xB4, 0xBB,0xE7,0xA9,0x8C, 0xEA,0x99,0x7E,0xE1, 0x4E,0xE7,0xE9,0xAE, 0xEE,0xE9,0xAE,0xB4, 0x7E,0xEB,0xE9,0xEE};

//Slot 14 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S14[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x53, 0x81,0x5E,0x82,0x51, 0x82,0x58,0x81,0x46,
 0x82,0x53,0x82,0x53, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x52, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x5C,0x67, 0xB9,0x4A,0x06,0x2D, 0x12,0x3A,0xEE,0x61, 0xD1,0x49,0xCA,0x6D, 0xA8,0x7D,0x90,0x31, 0x86,0x7D,0xD5,0x1C, 0x08,0x25,0xD1,0x1C, 0xEB,0x1C,0xFF,0x7F,
 0xFF,0xFF,0xFF,0x11, 0x11,0xFF,0xFF,0xFF, 0xAF,0xAA,0xDA,0xDB, 0xBD,0xA9,0xAA,0xFA, 0xAF,0xBA,0xBB,0xBD, 0xBD,0x9D,0xAA,0xFA, 0xAF,0xDA,0xBD,0xBB, 0xDD,0xDD,0xA5,0xFA,
 0xAF,0x9A,0xDD,0xBB, 0xED,0xDD,0x59,0xFA, 0xAF,0xBA,0xDD,0x9C, 0xEC,0xC9,0xDD,0xFA, 0xAF,0xBA,0xEE,0xCE, 0x9E,0xEE,0xDD,0xFA, 0xAF,0xBA,0x9E,0x12, 0x11,0xE2,0xB9,0xFA,
 0xAF,0x9A,0x44,0x44, 0x22,0xE4,0xB5,0xFA, 0x81,0x66,0x49,0xC9, 0x24,0x9C,0xDA,0xFA, 0xB6,0xDB,0x4C,0xF1, 0x21,0xE9,0xDA,0xFA, 0xDB,0x36,0x94,0x12, 0x21,0xE9,0x9A,0xFA,
 0x71,0x33,0x41,0x29, 0x91,0xAE,0xAA,0xFA, 0x35,0x93,0x1F,0x9E, 0xE9,0x33,0xAA,0xFA, 0x33,0x93,0x1F,0x44, 0x1E,0x39,0x83,0xFA, 0x33,0x93,0x11,0x24, 0x19,0x39,0x13,0xFF};

//Slot 15 Header
const quint8 PSX_SAVE_GAME_FILE_HEADER_S15[0x100]=
{0x53,0x43,0x11,0x01, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x54, 0x81,0x5E,0x82,0x58, 0x82,0x58,0x81,0x46,
 0x82,0x54,0x82,0x58, 0x00,0x00,0x00,0x00, 0x82,0x65,0x82,0x65, 0x82,0x56,0x81,0x5E, 0x82,0x72,0x82,0x60, 0x82,0x75,0x82,0x64, 0x82,0x50,0x82,0x53, 0x81,0x5E,0x82,0x50,
 0x82,0x50,0x81,0x46, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00, 0x00,0x00,0x00,0x00,
 0x00,0x00,0x5C,0x67, 0x37,0x67,0xB9,0x4E, 0xB2,0x5A,0x37,0x3A, 0x34,0x42,0x50,0x4E, 0xCF,0x39,0xA8,0x71, 0xAA,0x59,0xAB,0x45, 0xAC,0x35,0x86,0x7D, 0x29,0x25,0xFF,0x7F,
 0x1F,0x77,0xEB,0xEE, 0xF2,0x21,0x42,0xEE, 0x9F,0xB7,0xBE,0xE8, 0xFC,0x2F,0x22,0xB4, 0x9F,0xE7,0xEE,0x68, 0x46,0x2F,0x24,0x42, 0x9F,0xE4,0x39,0xF1, 0x63,0x42,0x24,0x74,
 0x9F,0xE2,0x19,0xFF, 0x61,0x44,0x47,0x44, 0x9F,0xE1,0x19,0xFF, 0x83,0x47,0xCC,0x77, 0xDF,0xE2,0xBD,0x51, 0x8E,0x78,0x6C,0x8C, 0xDF,0xE4,0xAD,0x13, 0x63,0x87,0x68,0xEC,
 0xDF,0xE4,0x9D,0xF1, 0xFF,0xC7,0x68,0xEC, 0xDF,0xB7,0xDD,0x14, 0xFF,0xE7,0x55,0xCE, 0xDF,0xBA,0xDD,0x6B, 0xF1,0xE6,0x65,0xCE, 0xDF,0xAD,0x9A,0x4E, 0xF1,0xE3,0xE5,0xCC,
 0xDF,0x9D,0xEE,0xEE, 0x11,0xE5,0xE3,0xCC, 0xDF,0xDD,0xE8,0xEE, 0xEE,0xE5,0xE1,0x8C, 0xDF,0xDD,0x8C,0xEE, 0xEE,0x45,0xE1,0x8C, 0xFF,0xFF,0xC1,0xE8, 0xEE,0x13,0xE3,0x78};

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~PSV SAVE INFO~~~~~~~~~~~~~~~~~~~~~~~~~*/
const int FF7_PSV_SAVE_GAME_SIZE = 0x2084;
const int FF7_PSV_SAVE_GAME_HEADER = 0x0084;
const int FF7_PSV_SAVE_GAME_FOOTER = 0x0000;
const int FF7_PSV_SAVE_GAME_DATA_SIZE = 0x10F4;
const int FF7_PSV_SAVE_GAME_SLOT_HEADER = 0x0200;
const int FF7_PSV_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
const int FF7_PSV_SAVE_GAME_SLOT_SIZE = 0x2000;
const int FF7_PSV_SAVE_GAME_SLOT_NUMBER = 1;
const QByteArray PSV_SAVE_GAME_FILE_ID = "\x00\x56\x53\x50";

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~Mem Card Format~~~~~~~~~~~~~~~~~~~*/
const int FF7_MC_SAVE_GAME_SIZE = 0x20000;
const int FF7_MC_SAVE_GAME_HEADER = 0x2000;
const int FF7_MC_SAVE_GAME_FOOTER = 0x0000;
const int FF7_MC_SAVE_GAME_DATA_SIZE = 0x10F4;
const int FF7_MC_SAVE_GAME_SLOT_HEADER = 0x0200;
const int FF7_MC_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
const int FF7_MC_SAVE_GAME_SLOT_SIZE = 0x2000;
const int FF7_MC_SAVE_GAME_SLOT_NUMBER = 15;
const QByteArray MC_SAVE_GAME_FILE_ID = "\x4D\x43";
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~PSP SAVE FORMAT~~~~~~~~~~~~~~~~~~~*/
const int FF7_PSP_SAVE_GAME_SIZE = 0x20080;
const int FF7_PSP_SAVE_GAME_HEADER = 0x2080;
const int FF7_PSP_SAVE_GAME_FOOTER = 0x0000;
const int FF7_PSP_SAVE_GAME_DATA_SIZE = 0x10F4;
const int FF7_PSP_SAVE_GAME_SLOT_HEADER = 0x0200;
const int FF7_PSP_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
const int FF7_PSP_SAVE_GAME_SLOT_SIZE = 0x2000;
const int FF7_PSP_SAVE_GAME_SLOT_NUMBER = 15;
const QByteArray PSP_SAVE_GAME_FILE_ID = "\x00\x50\x4D\x56";
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~VGM SAVE FORMAT~~~~~~~~~~~~~~~~~~~~*/
const int FF7_VGS_SAVE_GAME_SIZE = 0x20040;
const int FF7_VGS_SAVE_GAME_HEADER = 0x2040;
const int FF7_VGS_SAVE_GAME_FOOTER = 0x0000;
const int FF7_VGS_SAVE_GAME_DATA_SIZE = 0x10F4;
const int FF7_VGS_SAVE_GAME_SLOT_HEADER = 0x0200;
const int FF7_VGS_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
const int FF7_VGS_SAVE_GAME_SLOT_SIZE = 0x2000;
const int FF7_VGS_SAVE_GAME_SLOT_NUMBER = 15;
const QByteArray VGS_SAVE_GAME_FILE_ID = "\x56\x67\x73\x4D";
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~DEX SAVE FORMAT~~~~~~~~~~~~~~~~~~~~*/
const int FF7_DEX_SAVE_GAME_SIZE = 0x20F40;
const int FF7_DEX_SAVE_GAME_HEADER = 0x2F40;
const int FF7_DEX_SAVE_GAME_FOOTER = 0x0000;
const int FF7_DEX_SAVE_GAME_DATA_SIZE = 0x10F4;
const int FF7_DEX_SAVE_GAME_SLOT_HEADER = 0x0200;
const int FF7_DEX_SAVE_GAME_SLOT_FOOTER = 0x0D0C;
const int FF7_DEX_SAVE_GAME_SLOT_SIZE = 0x2000;
const int FF7_DEX_SAVE_GAME_SLOT_NUMBER = 15;
const QByteArray DEX_SAVE_GAME_FILE_ID= "\x31\x32\x33\x2D\x34\x35\x36\x2D\x53\x54\x44";
/*~~~~~~~~~~~~~~~~raw default save game~~~~~~~~~~~~~~~~*/
static const quint8 default_save[0x10F4] =
{
    0xcd, 0x2a, 0x00, 0x00, 0x01, 0x00, 0xff, 0xff, 0x25, 0x58, 0x0d, 0x33, 0x2f, 0x2c, 0x24, 0x29,
    0x25, 0x32, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xfd, 0x00, 0x40, 0x01, 0x36, 0x00, 0x39, 0x00,
    0xf0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x4c, 0x41, 0x54, 0x46, 0x4f, 0x52, 0x4d,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x58, 0xb0, 0x00, 0x00, 0x50, 0x00, 0x00,
    0x80, 0x00, 0x00, 0x20, 0x00, 0x06, 0x14, 0x10, 0x13, 0x11, 0x06, 0x0e, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x80, 0x25, 0x58, 0x0d, 0x33, 0x2f, 0x2c, 0x24, 0x29, 0x25, 0x32, 0xff, 0xff,
    0x00, 0x00, 0xff, 0x00, 0xff, 0x1d, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x3a, 0x01, 0x3a, 0x01, 0x36, 0x00, 0x36, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3a, 0x01, 0x36, 0x00,
    0x62, 0x02, 0x00, 0x00, 0x34, 0x00, 0x00, 0x00, 0x32, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x23, 0x00, 0x00, 0x00, 0x01, 0x01, 0x0f, 0x0d, 0x0b, 0x09, 0x05, 0x0d,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x80, 0x22, 0x41, 0x52, 0x52, 0x45, 0x54, 0xff, 0xff,
    0x00, 0xff, 0xff, 0xff, 0x20, 0x00, 0xff, 0x00, 0xff, 0x1b, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xde, 0x00, 0xde, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xde, 0x00, 0x0f, 0x00, 0x0a, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x02, 0x01, 0x0b, 0x0b,
    0x0b, 0x0a, 0x07, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x19, 0x34, 0x49, 0x46, 0x41,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x10, 0x00, 0xff, 0x00, 0xff, 0x00, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xdb, 0x00, 0xdb, 0x00, 0x10, 0x00, 0x10, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xdb, 0x00, 0x10, 0x00, 0x08, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
    0x03, 0x01, 0x0a, 0x0b, 0x0d, 0x0e, 0x05, 0x0e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x14,
    0x21, 0x45, 0x52, 0x49, 0x54, 0x48, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x3e, 0x00, 0xff, 0x00,
    0xfe, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb1, 0x00, 0xb1, 0x00,
    0x17, 0x00, 0x17, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x00, 0x00, 0x00, 0x00, 0x04, 0x01, 0x0a, 0x0c, 0x0b, 0x0a, 0x0a, 0x0e, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x6a, 0x32, 0x45, 0x44, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x30, 0x03, 0xff, 0x00, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xdd, 0x00, 0xdd, 0x00, 0x11, 0x00, 0x11, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff,
    0x0c, 0x00, 0x00, 0x00, 0x31, 0xe8, 0x03, 0x00, 0x17, 0xe8, 0x03, 0x00, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x25, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x05, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x2b, 0x39, 0x55, 0x46, 0x46, 0x49, 0x45, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x57, 0x04, 0xff, 0x00, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x64, 0x00, 0x64, 0x00, 0x05, 0x00, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x27, 0x2c, 0x01, 0x00, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x09, 0x01, 0x0c, 0x0c,
    0x0b, 0x0a, 0x06, 0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x23, 0x4c, 0x4f, 0x55,
    0x44, 0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0x01, 0x00, 0x00, 0xfe, 0x07, 0x01, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x8c, 0x00, 0x8c, 0x00, 0x04, 0x00, 0x04, 0x00,
    0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0x0c, 0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x74, 0x00, 0x00, 0x00,
    0x0a, 0x32, 0x55, 0x48, 0x44, 0x46, 0x41, 0x2e, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x00,
    0x33, 0x45, 0x50, 0x48, 0x49, 0x52, 0x4f, 0x54, 0x48, 0xff, 0xff, 0xff, 0x7f, 0x06, 0x08, 0x00,
    0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x0f,
    0xcc, 0x01, 0xcc, 0x01, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xb6, 0xe3, 0x04, 0x00,
    0x37, 0xff, 0xff, 0xff, 0x35, 0xff, 0xff, 0xff, 0x33, 0xff, 0xff, 0xff, 0x17, 0xff, 0xff, 0xff,
    0x31, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x32, 0xff, 0xff, 0xff, 0x17, 0xff, 0xff, 0xff, 0x34, 0xff, 0xff, 0xff, 0x17, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xaa, 0xe8, 0x00, 0x00, 0x08, 0x01, 0x0c, 0x0c, 0x0b, 0x0a, 0x06, 0x0e, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x01, 0x3f, 0x23, 0x49, 0x44, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0x49, 0x06, 0xff, 0x00, 0xff, 0x00, 0x01, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xdf, 0x00, 0xdf, 0x00, 0x0f, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff,
    0x12, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0x06, 0x03, 0x02,
    0x07, 0x02, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xf0, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xb3, 0x4b, 0x00, 0x00, 0xb3, 0x4b, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x74, 0x00, 0x00, 0x00, 0x47, 0x0e, 0x28, 0x6b, 0x19, 0x00,
    0x60, 0x40, 0x0d, 0x00, 0x00, 0x00, 0x00, 0x32, 0x1e, 0x0a, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x03, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0xfb, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x64, 0x64, 0x64, 0x64, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0xff,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x14, 0x00, 0x00, 0x00, 0xe2, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x4c, 0x41, 0x54,
    0x46, 0x4F, 0x52, 0x4d, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x01, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x41, 0x00, 0x00, 0x01, 0x02, 0x03,
    0x04, 0x05, 0x06, 0x07, 0x08, 0x09, 0x0a, 0x0b, 0x0c, 0x0d, 0x0e, 0x0f, 0x80, 0x00, 0x00, 0x00,
    0x00, 0x00, 0x00, 0x00
};

/*LEVEL CHART */
static const quint32 charlvls[11][99]=
{
    {0,6,33,94,202,372,616,949,1384,1934,2614,3588,4610,5809,7200,8797,10614,12665,14965,17528,20368,24161,27694,31555,35759,40321,45255,50576,56299,62438,69008,77066,84643,92701,101255,110320,119910,130040,140725,151980,163820,176259,189312,202994,217320,232305,247963,264309,281358,299125,317625,336872,356881,377667,399245,421630,444836,468878,493771,519530,546170,581467,610297,640064,670784,702471,735141,768808,803488,839195,875945,913752,952632,992599,1033669,1075856,1119176,1163643,1209273,1256080,1304080,1389359,1441133,1494178,1548509,1604141,1661090,1719371,1778999,1839990,1902360,1966123,2031295,2097892,2165929,2235421,2306384,2378833,2452783},
    {0,7,35,98,210,385,637,980,1428,1995,2695,3689,4740,5973,7403,9045,10913,13022,15387,18022,20942,24827,28457,32424,36744,41431,46501,51968,57848,64155,70905,79149,86931,95207,103992,113302,123151,133555,144529,156088,168248,183403,196985,211222,226129,241721,258014,275023,292763,311250,330500,350527,371347,392976,415429,438721,462868,487885,513787,540590,568310,596961,626559,657120,688659,721191,754732,789297,824901,861560,899290,938105,978021,1019054,1061219,1104531,1149006,1194659,1241505,1289560,1338840,1389359,1441133,1494178,1548509,1604141,1661090,1719371,1778999,1839990,1902360,1966123,2031295,2097892,2165929,2235421,2306384,2378833,2452783},
    {0,6,33,94,202,372,616,949,1384,1934,2614,3588,4610,5809,7200,8797,10614,12665,14965,17528,20368,24161,27694,31555,35759,40321,45255,50576,56299,62438,69008,77066,84643,92701,101255,110320,119910,130040,140725,151980,163820,178647,191877,205744,220264,235451,251321,267888,285168,303175,321925,341432,361712,382779,404649,427336,450856,475223,500453,526560,553560,581467,610297,640064,670784,702471,735141,768808,803488,839195,875945,913752,952632,992599,1033669,1075856,1119176,1163643,1209273,1256080,1304080,1371319,1422421,1474777,1528402,1583312,1639521,1697045,1755899,1816098,1877658,1940593,2004919,2070651,2137804,2206394,2276435,2347943,2420933},
    {0,6,32,92,199,366,607,935,1363,1905,2575,3542,4550,5733,7105,8680,10472,12495,14763,17290,20090,23831,27315,31123,35270,39770,44637,49885,55529,61584,68064,77066,84643,92701,101255,110320,119910,130040,140725,151980,163820,176259,189312,202994,217320,232305,247963,264309,281358,299125,317625,341432,361712,382779,404649,427336,450856,475223,500453,526560,553560,589211,618425,648589,679718,711828,744933,779049,814191,850374,887614,925925,965323,1005823,1047440,1090190,1134087,1179147,1225385,1272816,1321456,1407407,1459854,1513588,1568624,1624979,1682667,1741705,1802108,1863891,1927071,1991662,2057681,2125143,2194063,2264458,2336342,2409732,2484643},
    {0,6,33,94,202,372,616,949,1384,1934,2614,3588,4610,5809,7200,8797,10614,12665,14965,17528,20368,24493,28074,31988,36250,40875,45877,51271,57072,63295,69955,78112,85792,93959,102629,111816,121536,131803,142633,154040,166040,178647,191877,205744,220264,235451,251321,267888,285168,303175,321925,341432,361712,382779,404649,427336,450856,475223,500453,526560,553560,589211,618425,648589,679718,711828,744933,779049,814191,850374,887614,925925,965323,1005823,1047440,1090190,1134087,1179147,1225385,1272816,1321456,1371319,1422421,1474777,1528402,1583312,1639521,1697045,1755899,1816098,1877658,1940593,2004919,2070651,2137804,2206394,2276435,2347943,2420933},
    {0,6,33,95,205,377,625,963,1404,1962,2652,3639,4675,5891,7302,8922,10765,12845,15177,17776,20656,24827,28457,32424,36744,41431,46501,51968,57848,64155,70905,78112,85792,93959,102629,111816,121536,131803,142633,154040,166040,181023,194429,208481,223194,238584,254665,271453,288963,307210,326210,345977,366527,387875,410036,433026,456859,481551,507117,533572,560932,596961,626559,657120,688659,721191,754732,789297,824901,861560,899290,938105,978021,1019054,1061219,1104531,1149006,1194659,1241505,1289560,1338840,1389359,1441133,1494178,1548509,1604141,1661090,1719371,1778999,1839990,1902360,1966123,2031295,2097892,2165929,2235421,2306384,2378833,2452783},
    {0,6,33,95,205,377,625,963,1404,1962,2652,3639,4675,5891,7302,8922,10765,12845,15177,17776,20656,24827,28457,32424,36744,41431,46501,51968,57848,64155,70905,78112,85792,93959,102629,111816,121536,131803,142633,154040,166040,178647,191877,205744,220264,235451,251321,267888,285168,303175,321925,345977,366527,387875,410036,433026,456859,481551,507117,533572,560932,589211,618425,648589,679718,711828,744933,779049,814191,850374,887614,925925,965323,1005823,1047440,1090190,1134087,1179147,1225385,1272816,1321456,1371319,1422421,1474777,1528402,1583312,1639521,1697045,1755899,1816098,1877658,1940593,2004919,2070651,2137804,2206394,2276435,2347943,2420933},
    {0,7,35,98,210,385,637,980,1428,1995,2695,3639,4675,5891,7302,8922,10765,12845,15177,17776,20656,24827,28457,32424,36744,41431,46501,51968,57848,64155,70905,79149,86931,95207,103992,113302,123151,133555,144529,156088,168248,181023,194429,208481,223194,238584,254665,271453,288963,307210,326210,345977,366527,387875,410036,433026,456859,481551,507117,533572,560932,589211,618425,648589,679718,711828,744933,779049,814191,850374,887614,925925,965323,1005823,1047440,1090190,1134087,1179147,1225385,1272816,1321456,1371319,1422421,1474777,1528402,1583312,1639521,1697045,1755899,1816098,1877658,1940593,2004919,2070651,2137804,2206394,2276435,2347943,2420933},
    {0,6,33,95,205,377,625,963,1404,1962,2652,3639,4675,5891,7302,8922,10765,12845,15177,17776,20656,24827,28457,32424,36744,41431,46501,51968,57848,64155,70905,78112,85792,93959,102629,111816,121536,131803,142633,154040,166040,181023,194429,208481,223194,238584,254665,271453,288963,307210,326210,345977,366527,387875,410036,433026,456859,481551,507117,533572,560932,596961,626559,657120,688659,721191,754732,789297,824901,861560,899290,938105,978021,1019054,1061219,1104531,1149006,1194659,1241505,1289560,1338840,1389359,1441133,1494178,1548509,1604141,1661090,1719371,1778999,1839990,1902360,1966123,2031295,2097892,2165929,2235421,2306384,2378833,2452783},
    {0,13,65,182,390,715,1183,1820,2652,3705,5005,7084,9100,11466,14210,17360,20944,24990,29526,34580,40180,46354,53130,60536,68600,77350,86814,97020,107996,119770,132370,114576,125840,137819,150535,164010,178266,193325,209209,225940,243540,214389,230265,246906,264330,282555,301599,321480,342216,363825,386325,318682,337610,357273,377685,398860,420812,443555,467103,491470,516670,372124,390575,409626,429286,449566,470474,492021,514216,537068,560588,584784,609667,635246,661530,688530,716254,744713,773916,803872,834592,487154,505308,523908,542959,562466,582435,602871,623779,645165,667035,689393,712245,735597,759454,783821,808704,834108,860038},
    {0,6,33,94,202,372,616,949,1384,1934,2614,3588,4610,5809,7200,8797,10614,12665,14965,17528,20368,24161,27694,31555,35759,40321,45255,50576,56299,62438,69008,77066,84643,92701,101255,110320,119910,130040,140725,151980,163820,176259,189312,202994,217320,232305,247963,264309,281358,299125,317625,336872,356881,377667,399245,421630,444836,468878,493771,519530,546170,581467,610297,640064,670784,702471,735141,768808,803488,839195,875945,913752,952632,992599,1033669,1075856,1119176,1163643,1209273,1256080,1304080,1389359,1441133,1494178,1548509,1604141,1661090,1719371,1778999,1839990,1902360,1966123,2031295,2097892,2165929,2235421,2306384,2378833,2452783}
};
static const quint32 chartnls[11][99]=
{
    {0,6,27,61,108,170,244,333,435,550,680,974,1022,1199,1391,1597,1817,2051,2300,2563,2840,3793,3533,3861,4204,4562,4934,5321,5723,6139,6570,8058,7577,8058,8554,9065,9590,10130,10685,11255,11840,12439,13053,13682,14326,14985,15658,16346,17049,17767,18500,19247,20009,20786,21578,22385,23206,24042,24893,25759,26640,35297,28830,29767,30720,31687,32670,33667,34680,35707,36750,37807,38880,39967,41070,42187,43320,44467,45630,46807,48000,85279,51774,53045,54331,55632,56949,58281,59628,60991,62370,63763,65172,66597,68037,69492,70963,72449,73950},
    {0,7,28,63,112,175,252,343,448,567,700,994,1051,1233,1430,1642,1868,2109,2365,2635,2920,3885,3630,3967,4320,4687,5070,5467,5880,6307,6750,8244,7782,8276,8785,9310,9849,10404,10974,11559,12160,15155,13582,14237,14907,15592,16293,17009,17740,18487,19250,20027,20820,21629,22453,23292,24147,25017,25902,26803,27720,28651,29598,30561,31539,32532,33541,34565,35604,36659,37730,38815,39916,41033,42165,43312,44475,45653,46846,48055,49280,50519,51774,53045,54331,55632,56949,58281,59628,60991,62370,63763,65172,66597,68037,69492,70963,72449,73950},
    {0,6,27,61,108,170,244,333,435,550,680,974,1022,1199,1391,1597,1817,2051,2300,2563,2840,3793,3533,3861,4204,4562,4934,5321,5723,6139,6570,8058,7577,8058,8554,9065,9590,10130,10685,11255,11840,14827,13230,13867,14520,15187,15870,16567,17280,18007,18750,19507,20280,21067,21870,22687,23520,24367,25230,26107,27000,27907,28830,29767,30720,31687,32670,33667,34680,35707,36750,37807,38880,39967,41070,42187,43320,44467,45630,46807,48000,67239,51102,52356,53625,54910,56209,57524,58854,60199,61560,62935,64326,65732,67153,68590,70041,71508,72990},
    {0,6,26,60,107,167,241,328,428,542,670,967,1008,1183,1372,1575,1792,2023,2268,2527,2800,3741,3484,3808,4147,4500,4867,5248,5644,6055,6480,9002,7577,8058,8554,9065,9590,10130,10685,11255,11840,12439,13053,13682,14326,14985,15658,16346,17049,17767,18500,23807,20280,21067,21870,22687,23520,24367,25230,26107,27000,35651,29214,30164,31129,32110,33105,34116,35142,36183,37240,38311,39398,40500,41617,42750,43897,45060,46238,47431,48640,85951,52447,53734,55036,56355,57688,59038,60403,61783,63180,64591,66019,67462,68920,70395,71884,73390,74911},
    {0,6,27,61,108,170,244,333,435,550,680,974,1022,1199,1391,1597,1817,2051,2300,2563,2840,4125,3581,3914,4262,4625,5002,5394,5801,6223,6660,8157,7680,8167,8670,9187,9720,10267,10830,11407,12000,12607,13230,13867,14520,15187,15870,16567,17280,18007,18750,19507,20280,21067,21870,22687,23520,24367,25230,26107,27000,35651,29214,30164,31129,32110,33105,34116,35142,36183,37240,38311,39398,40500,41617,42750,43897,45060,46238,47431,48640,49863,51102,52356,53625,54910,56209,57524,58854,60199,61560,62935,64326,65732,67153,68590,70041,71508,72990},
    {0,6,27,62,110,172,248,338,441,558,690,987,1036,1216,1411,1620,1843,2080,2332,2599,2880,4171,3630,3967,4320,4687,5070,5467,5880,6307,6750,7207,7680,8167,8670,9187,9720,10267,10830,11407,12000,14983,13406,14052,14713,15390,16081,16788,17510,18247,19000,19767,20550,21348,22161,22990,23833,24692,25566,26455,27360,36029,29598,30561,31539,32532,33541,34565,35604,36659,37730,38815,39916,41033,42165,43312,44475,45653,46846,48055,49280,50519,51774,53045,54331,55632,56949,58281,59628,60991,62370,63763,65172,66597,68037,69492,70963,72449,73950},
    {0,6,27,62,110,172,248,338,441,558,690,987,1036,1216,1411,1620,1843,2080,2332,2599,2880,4171,3630,3967,4320,4687,5070,5467,5880,6307,6750,7207,7680,8167,8670,9187,9720,10267,10830,11407,12000,12607,13230,13867,14520,15187,15870,16567,17280,18007,18750,24052,20550,21348,22161,22990,23833,24692,25566,26455,27360,28279,29214,30164,31129,32110,33105,34116,35142,36183,37240,38311,39398,40500,41617,42750,43897,45060,46238,47431,48640,49863,51102,52356,53625,54910,56209,57524,58854,60199,61560,62935,64326,65732,67153,68590,70041,71508,72990},
    {0,7,28,63,112,175,252,343,448,567,700,944,1036,1216,1411,1620,1843,2080,2332,2599,2880,4171,3630,3967,4320,4687,5070,5467,5880,6307,6750,8244,7782,8276,8785,9310,9849,10404,10974,11559,12160,12775,13406,14052,14713,15390,16081,16788,17510,18247,19000,19767,20550,21348,22161,22990,23833,24692,25566,26455,27360,28279,29214,30164,31129,32110,33105,34116,35142,36183,37240,38311,39398,40500,41617,42750,43897,45060,46238,47431,48640,49863,51102,52356,53625,54910,56209,57524,58854,60199,61560,62935,64326,65732,67153,68590,70041,71508,72990},
    {0,6,27,62,110,172,248,338,441,558,690,987,1036,1216,1411,1620,1843,2080,2332,2599,2880,4171,3630,3967,4320,4687,5070,5467,5880,6307,6750,7207,7680,8167,8670,9187,9720,10267,10830,11407,12000,14983,13406,14052,14713,15390,16081,16788,17510,18247,19000,19767,20550,21348,22161,22990,23833,24692,25566,26455,27360,36029,29598,30561,31539,32532,33541,34565,35604,36659,37730,38815,39916,41033,42165,43312,44475,45653,46846,48055,49280,50519,51774,53045,54331,55632,56949,58281,59628,60991,62370,63763,65172,66597,68037,69492,70963,72449,73950},
    {0,13,52,117,208,325,468,637,832,1053,1300,2079,2016,2366,2744,3150,3584,4046,4536,5054,5600,6174,6776,7406,8064,8750,9464,10206,10976,11774,12600,-17794,11264,11979,12716,13475,14256,15059,15884,16731,17600,-29151,15876,16641,17424,18225,19044,19881,20736,21609,22500,-67643,18928,19663,20412,21175,21952,22743,23548,24367,25200,-144546,18451,19051,19660,20280,20908,21547,22195,22852,23520,24196,24883,25579,26284,27000,27724,28459,29203,29956,30720,-347438,18154,18600,19051,19507,19969,20436,20908,21386,21870,22358,22852,23352,23857,24367,24883,25404,25930},
    {0,6,27,61,108,170,244,333,435,550,680,974,1022,1199,1391,1597,1817,2051,2300,2563,2840,3793,3533,3861,4204,4562,4934,5321,5723,6139,6570,8058,7577,8058,8554,9065,9590,10130,10685,11255,11840,12439,13053,13682,14326,14985,15658,16346,17049,17767,18500,19247,20009,20786,21578,22385,23206,24042,24893,25759,26640,35297,28830,29767,30720,31687,32670,33667,34680,35707,36750,37807,38880,39967,41070,42187,43320,44467,45630,46807,48000,85279,51774,53045,54331,55632,56949,58281,59628,60991,62370,63763,65172,66597,68037,69492,70963,72449,73950}
};

static const quint8 stat_grade[9][5]=
{
  {1,6,3,4,26},
  {5,2,18,14,29},
  {6,18,16,9,25},
  {23,20,0,1,28},
  {12,11,13,9,23},
  {16,19,11,10,24},
  {19,22,6,4,28},
  {21,22,6,4,28},
  {11,7,17,15,27}
};
static const int mp_base[9][8]=
{
    {12,0,-26,-58,-102,-102,-4,180},
    {10,0,-20,-60,-108,-96,0,170},
    {10,0,-28,-58,-98,-98,-26,136},
    {16,0,-30,-68,-116,-96,-6,188},
    {12,-6,-28,-60,-104,-126,-16,210},
    {10,-2,-20,-58,-110,-130,20,126},
    {12,-2,-20,-60,-104,-104,-20,178},
    {12,-6,-26,-44,-60,-86,38,74},
    {10,-12,-26,-38,-66,-116,69,140}
};
static const quint8 mp_gradent[9][8]=
{
    {64,78,90,101,112,112,96,73},
    {57,67,77,90,102,100,84,63},
    {60,70,84,94,104,104,92,72},
    {70,84,99,112,124,120,105,82},
    {58,75,86,97,108,112,94,66},
    {58,72,80,93,106,110,85,72},
    {60,75,83,97,108,108,94,70},
    {63,80,90,96,100,105,97,84},
    {54,75,83,87,94,104,89,69}
};
static const int hp_base[9][8]=
{
    {200,-40,-640,-1440,-2280,-3080,-2040,-200},
    {200,0,-760,-1840,-2840,-2840,-1160,600},
    {200,0,-520,-1520,-2520,-3000,-2160,-80},
    {160,0,-560,-1400,-2240,-2880,-2080,-400},
    {200,-40,-640,-1560,-2360,-2760,-1840,-80},
    {200,0,-560,-1320,-2160,-2960,-2560,-520},
    {200,-80,-640,-1640,-2760,-2600,-240,2000},
    {160,-80,-600,-1160,-2120,-2800,-2640,-400},
    {200,-40,-640,-1640,-2360,-2560,-1720,-0}
};
static const quint8 hp_gradent[9][8]=
{
    {19,42,72,100,121,137,120,98},
    {22,45,82,118,143,143,115,95},
    {19,38,64,96,121,131,117,92},
    {17,36,65,93,114,126,113,93},
    {21,45,75,105,126,134,119,97},
    {18,37,64,89,111,127,120,96},
    {24,51,80,111,141,138,99,72},
    {18,41,67,86,110,123,120,92},
    {23,44,73,107,125,129,115,93}
};
static const quint8 luck_base[9][8]=
{
    {15,16,16,17,17,17,18,19},
    {14,15,15,15,16,17,18,20},
    {14,15,15,16,17,17,17,20},
    {14,15,15,16,16,18,17,17},
    {14,15,15,16,16,18,17,17},
    {16,17,17,17,18,18,18,19},
    {14,15,15,16,17,17,17,20},
    {14,15,15,16,17,17,17,20},
    {14,15,15,15,16,17,18,20}
};
static const quint8 luck_gradent[9][8]=
{
    {20,10,10,8,8,8,7,6},
    {15,8,8,7,6,5,4,3},
    {20,10,10,9,9,10,10,6},
    {18,8,8,8,8,5,7,7},
    {18,8,8,8,8,5,7,7},
    {20,10,10,10,8,10,10,9},
    {20,10,10,9,9,10,10,6},
    {20,10,10,9,9,10,10,6},
    {15,8,8,7,6,5,4,3}
};
static const quint8 stat_base[30][8]=
{
    {12,9,9,21,44,50,57,73},
    {13,12,11,11,17,43,53,80},
    {12,10,11,21,32,42,56,73},
    {12,13,11,15,33,40,51,69},
    {10,9,8,8,30,33,40,61},
    {12,12,14,14,23,49,55,62},
    {10,8,5,17,17,30,50,61},
    {11,10,11,16,27,33,37,58},
    {12,9,10,11,29,34,49,58},
    {9,8,8,8,26,29,42,48},
    {9,9,7,8,11,26,48,53},
    {11,10,12,17,21,49,48},
    {9,9,6,8,29,51,57,62},
    {10,9,7,16,22,43,45,54},
    {8,9,11,13,16,18,40,60},
    {9,9,11,15,23,32,48,62},
    {10,9,10,16,22,28,49,55},
    {10,10,10,13,21,39,45,57},
    {10,10,9,11,21,35,51,57},
    {9,8,9,17,32,37,42,47},
    {10,9,8,11,29,39,47,53},
    {8,7,4,20,31,36,37,46},
    {9,9,10,15,21,28,35,53},
    {9,9,8,14,18,25,44,50},
    {8,9,12,13,22,29,38,55},
    {7,7,1,8,13,20,42,46},
    {6,7,6,6,10,19,36,37},
    {6,9,8,6,7,13,31,37},
    {5,6,7,7,9,18,38,38},
    {5,6,4,9,14,20,24,30}
};
static const quint8 stat_gradent[30][8]=
{
    {130,160,160,120,70,60,50,30},
    {120,130,133,135,120,72,55,21},
    {130,140,140,110,90,70,48,27},
    {130,140,140,110,90,79,53,32},
    {120,128,130,130,77,72,61,35},
    {120,125,117,118,93,52,44,35},
    {110,130,145,110,100,95,44,31},
    {120,135,130,110,85,70,60,35},
    {100,130,125,120,77,67,43,31},
    {110,120,122,123,80,75,55,44},
    {100,115,124,118,107,78,42,36},
    {110,120,115,102,91,37,40,40},
    {100,122,140,135,83,40,30,25},
    {110,122,130,98,83,45,44,33},
    {110,105,104,102,93,87,51,25},
    {115,127,121,108,86,68,41,24},
    {114,118,114,95,82,71,37,30},
    {112,115,111,103,83,48,39,25},
    {100,108,115,108,83,55,31,24},
    {100,111,112,87,53,45,39,34},
    {100,108,114,106,63,45,33,26},
    {100,110,127,77,50,41,40,31},
    {100,102,101,88,70,57,45,24},
    {100,100,107,85,77,60,30,24},
    {95,90,88,85,62,52,39,18},
    {80,85,115,92,78,64,27,21},
    {72,69,76,77,68,50,22,21},
    {70,53,63,70,69,58,28,20},
    {70,70,70,71,67,48,16,16},
    {65,63,76,61,49,36,28,20}
};
#endif // FF7_SAVE_CONSTS_H
